Eno_new <- function(obs, posdim, na.action = na.pass, ncores = NULL) {

  #Check params:

  if (is.null(obs)) {
    stop("Parameter 'obs' cannot be NULL.")
  }
  if (!is.numeric(obs)) {
    stop("Parameter 'obs' must be a numeric array.")
  }

  if (is.null(posdim)) {
    stop("Parameter 'posdim' cannot be NULL.")
  }

  if (posdim %% 1 != 0 && !is.character(posdim)) {
#    if (is.null(dim(obs))) {   #a vector
#      posdim <- 1
#    } else if (length(dim(obs)) == 1) {
#      posdim <- 1
#    } else {
      stop("Parameter 'posdim' must be an integer or character.")
    }

  if (is.integer(posdim) && posdim > length(dim(obs))) {
    stop("Parameter 'posdim' excesses the dimension length of parameter 'obs'.")
  }
  if (is.character(posdim) && !any(posdim %in% names(dim(obs)))) {
    stop("Parameter 'posdim' does not match any dimension name of parameter 'obs'.")
  }


#  if (!is.null(dim(obs))) {
    effnumobs <- Apply(data = list(obs),
                       target_dims = posdim,
                       fun = .Eno,
                       na.action = na.action,
                       ncores = ncores)$output1
                 #parallel = parallel) 
    #effnumobs <- adrop(eno, 1)   #dont drop length(dim) = 1. Keep the dim same as input.
#  } else {
#    effnumobs <- .Eno(obs)
#  }
  return(effnumobs)
}

.Eno <- function(x, na.action) {

  if (length(sort(x)) > 1) {
    n <- length(sort(x))
    if (n == 0) {
      n <- 1
    }
    a <- acf(x, lag.max = n - 1, plot = FALSE,
             na.action = na.action)$acf[2:n, 1, 1]
    s <- 0
    for (k in 1:(n - 1)) {
      s <- s + (((n - k) / n) * a[k])
    }
    eno <- min(n / (1 + (2 * s)), n)
  } else {
    eno <- NA
  }
  eno
}

